package cn.ibizlab.businesscentral.core.base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.base.domain.TimezoneLocalizedName;
import cn.ibizlab.businesscentral.core.base.filter.TimezoneLocalizedNameSearchContext;
import cn.ibizlab.businesscentral.core.base.service.ITimezoneLocalizedNameService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.businesscentral.core.base.mapper.TimezoneLocalizedNameMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[时区的本地化名称] 服务对象接口实现
 */
@Slf4j
@Service("TimezoneLocalizedNameServiceImpl")
public class TimezoneLocalizedNameServiceImpl extends ServiceImpl<TimezoneLocalizedNameMapper, TimezoneLocalizedName> implements ITimezoneLocalizedNameService {

    @Autowired
    @Lazy
    private cn.ibizlab.businesscentral.core.base.service.ITimezoneDefinitionService timezonedefinitionService;

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public boolean save(TimezoneLocalizedName et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(TimezoneLocalizedName et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<TimezoneLocalizedName> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<TimezoneLocalizedName> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    public TimezoneLocalizedName getDraft(TimezoneLocalizedName et) {
        return et;
    }

    @Override
    @Transactional
    public boolean create(TimezoneLocalizedName et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getTimezonelocalizednameid()),et);
        return true;
    }

    @Override
    public void createBatch(List<TimezoneLocalizedName> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(TimezoneLocalizedName et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("timezonelocalizednameid",et.getTimezonelocalizednameid())))
            return false;
        CachedBeanCopier.copy(get(et.getTimezonelocalizednameid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<TimezoneLocalizedName> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public TimezoneLocalizedName get(String key) {
        TimezoneLocalizedName et = getById(key);
        if(et==null){
            et=new TimezoneLocalizedName();
            et.setTimezonelocalizednameid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public boolean checkKey(TimezoneLocalizedName et) {
        return (!ObjectUtils.isEmpty(et.getTimezonelocalizednameid()))&&(!Objects.isNull(this.getById(et.getTimezonelocalizednameid())));
    }

	@Override
    public List<TimezoneLocalizedName> selectByTimezonedefinitionid(String timezonedefinitionid) {
        return baseMapper.selectByTimezonedefinitionid(timezonedefinitionid);
    }

    @Override
    public void removeByTimezonedefinitionid(String timezonedefinitionid) {
        this.remove(new QueryWrapper<TimezoneLocalizedName>().eq("timezonedefinitionid",timezonedefinitionid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<TimezoneLocalizedName> searchDefault(TimezoneLocalizedNameSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<TimezoneLocalizedName> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<TimezoneLocalizedName>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<TimezoneLocalizedName> getTimezonelocalizednameByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<TimezoneLocalizedName> getTimezonelocalizednameByEntities(List<TimezoneLocalizedName> entities) {
        List ids =new ArrayList();
        for(TimezoneLocalizedName entity : entities){
            Serializable id=entity.getTimezonelocalizednameid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



